/*
	SHARP PC-G800 series emulator
	̑̋@\
*/

#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include "g800.h"

#if !defined(O_BINARY)
#	define O_BINARY	0
#endif

static char autoKeyText[0x8000];	/* ͂eLXg */
static char *autoKeyTextPointer = NULL;	/* ͂eLXg̓ǂݍ݈ʒu */
static uint8 autoKeyBuffer[8];	/* L[̓obt@ */
static uint8 *autoKeyBufferPointer = NULL;	/* L[̓obt@̓ǂݍ݈ʒu */
static uint8 autoKeyMod = 0;	/* L[͑ÕL[ft@CA */

/*
	g[Xo͂
*/
void z80log(const Z80stat *z)
{
	char buf[256];
	int states = Z80_STATES(z);

	printf("%s%dclocks (%dmsec)\n\n", z80regs(buf, z), states, states / (freqCPU / 1000));
}

#define MOD_CAPSUNLOCK	0xfc	/* zL[: CAPSbN */
#define MOD_CAPSLOCK	0xfd	/* zL[: CAPSbN */
#define MOD_KANA	0xfe	/* zL[: JibN */

/*
	L[Xg[N𓾂 (getAutoKeỷ)
*/
static int ankToKey(char ch, uint8 mod, uint8 *key)
{
	const uint8 key_08[] = { GKEY_BACKSPACE, 0 };	/* BS */
	const uint8 key_09[] = { GKEY_TAB, 0 };	/* HT */
	const uint8 key_0a[] = { GKEY_RETURN, 0 };	/* LF */
	const uint8 key_1c[] = { GKEY_RIGHT, 0 };
	const uint8 key_1d[] = { GKEY_LEFT, 0 };
	const uint8 key_1e[] = { GKEY_UP, 0 };
	const uint8 key_1f[] = { GKEY_DOWN, 0 };
	const uint8 key_20[] = { GKEY_SPACE, 0 };	/* SPACE */
	const uint8 key_21[] = { GKEY_2NDF, GKEY_Q, 0 };	/* ! */
	const uint8 key_22[] = { GKEY_2NDF, GKEY_W, 0 };	/* " */
	const uint8 key_23[] = { GKEY_2NDF, GKEY_E, 0 };	/* # */
	const uint8 key_24[] = { GKEY_2NDF, GKEY_R, 0 };	/* $ */
	const uint8 key_25[] = { GKEY_2NDF, GKEY_T, 0 };	/* % */
	const uint8 key_26[] = { GKEY_2NDF, GKEY_Y, 0 };	/* & */
	const uint8 key_27[] = { GKEY_2NDF, GKEY_U, 0 };	/* ' */
	const uint8 key_28[] = { GKEY_LKAKKO, 0 };	/* ( */
	const uint8 key_29[] = { GKEY_RKAKKO, 0 };	/* ) */
	const uint8 key_2a[] = { GKEY_ASTER, 0 };	/* * */
	const uint8 key_2b[] = { GKEY_PLUS, 0 };	/* + */
	const uint8 key_2c[] = { GKEY_COMMA, 0 };	/* , */
	const uint8 key_2d[] = { GKEY_MINUS, 0 };	/* - */
	const uint8 key_2e[] = { GKEY_PERIOD, 0 };	/* . */
	const uint8 key_2f[] = { GKEY_SLASH, 0 };	/* / */
	const uint8 key_30[] = { GKEY_0, 0 };	/* 0 */
	const uint8 key_31[] = { GKEY_1, 0 };	/* 1 */
	const uint8 key_32[] = { GKEY_2, 0 };	/* 2 */
	const uint8 key_33[] = { GKEY_3, 0 };	/* 3 */
	const uint8 key_34[] = { GKEY_4, 0 };	/* 4 */
	const uint8 key_35[] = { GKEY_5, 0 };	/* 5 */
	const uint8 key_36[] = { GKEY_6, 0 };	/* 6 */
	const uint8 key_37[] = { GKEY_7, 0 };	/* 7 */
	const uint8 key_38[] = { GKEY_8, 0 };	/* 8 */
	const uint8 key_39[] = { GKEY_9, 0 };	/* 9 */
	const uint8 key_3a[] = { GKEY_2NDF, GKEY_SEMICOLON, 0 };	/* : */
	const uint8 key_3b[] = { GKEY_SEMICOLON, 0 };	/* ; */
	const uint8 key_3c[] = { GKEY_2NDF, GKEY_I, 0 };	/* < */
	const uint8 key_3d[] = { GKEY_2NDF, GKEY_L, 0 };	/* = */
	const uint8 key_3e[] = { GKEY_2NDF, GKEY_O, 0 };	/* > */
	const uint8 key_3f[] = { GKEY_2NDF, GKEY_COMMA, 0 };	/* ? */
	const uint8 key_40[] = { GKEY_2NDF, GKEY_P, 0 };	/* @ */
	const uint8 key_41[] = { MOD_CAPSLOCK, GKEY_A, 0 };	/* A */
	const uint8 key_42[] = { MOD_CAPSLOCK, GKEY_B, 0 };	/* B */
	const uint8 key_43[] = { MOD_CAPSLOCK, GKEY_C, 0 };	/* C */
	const uint8 key_44[] = { MOD_CAPSLOCK, GKEY_D, 0 };	/* D */
	const uint8 key_45[] = { MOD_CAPSLOCK, GKEY_E, 0 };	/* E */
	const uint8 key_46[] = { MOD_CAPSLOCK, GKEY_F, 0 };	/* F */
	const uint8 key_47[] = { MOD_CAPSLOCK, GKEY_G, 0 };	/* G */
	const uint8 key_48[] = { MOD_CAPSLOCK, GKEY_H, 0 };	/* H */
	const uint8 key_49[] = { MOD_CAPSLOCK, GKEY_I, 0 };	/* I */
	const uint8 key_4a[] = { MOD_CAPSLOCK, GKEY_J, 0 };	/* J */
	const uint8 key_4b[] = { MOD_CAPSLOCK, GKEY_K, 0 };	/* K */
	const uint8 key_4c[] = { MOD_CAPSLOCK, GKEY_L, 0 };	/* L */
	const uint8 key_4d[] = { MOD_CAPSLOCK, GKEY_M, 0 };	/* M */
	const uint8 key_4e[] = { MOD_CAPSLOCK, GKEY_N, 0 };	/* N */
	const uint8 key_4f[] = { MOD_CAPSLOCK, GKEY_O, 0 };	/* O */
	const uint8 key_50[] = { MOD_CAPSLOCK, GKEY_P, 0 };	/* P */
	const uint8 key_51[] = { MOD_CAPSLOCK, GKEY_Q, 0 };	/* Q */
	const uint8 key_52[] = { MOD_CAPSLOCK, GKEY_R, 0 };	/* R */
	const uint8 key_53[] = { MOD_CAPSLOCK, GKEY_S, 0 };	/* S */
	const uint8 key_54[] = { MOD_CAPSLOCK, GKEY_T, 0 };	/* T */
	const uint8 key_55[] = { MOD_CAPSLOCK, GKEY_U, 0 };	/* U */
	const uint8 key_56[] = { MOD_CAPSLOCK, GKEY_V, 0 };	/* V */
	const uint8 key_57[] = { MOD_CAPSLOCK, GKEY_W, 0 };	/* W */
	const uint8 key_58[] = { MOD_CAPSLOCK, GKEY_X, 0 };	/* X */
	const uint8 key_59[] = { MOD_CAPSLOCK, GKEY_Y, 0 };	/* Y */
	const uint8 key_5a[] = { MOD_CAPSLOCK, GKEY_Z, 0 };	/* Z */
	const uint8 key_5b[] = { GKEY_2NDF, GKEY_A, 0 };	/* [ */
	const uint8 key_5c[] = { GKEY_2NDF, GKEY_G, 0 };	/* \ */
	const uint8 key_5d[] = { GKEY_2NDF, GKEY_S, 0 };	/* ] */
	const uint8 key_5e[] = { GKEY_HAT, 0 };	/* ^ */
	const uint8 key_5f[] = { GKEY_2NDF, GKEY_K, 0 };	/* _ */
	const uint8 key_60[] = { GKEY_SPACE, 0 };	/* ` */
	const uint8 key_61[] = { MOD_CAPSUNLOCK, GKEY_A, 0 };	/* A */
	const uint8 key_62[] = { MOD_CAPSUNLOCK, GKEY_B, 0 };	/* B */
	const uint8 key_63[] = { MOD_CAPSUNLOCK, GKEY_C, 0 };	/* C */
	const uint8 key_64[] = { MOD_CAPSUNLOCK, GKEY_D, 0 };	/* D */
	const uint8 key_65[] = { MOD_CAPSUNLOCK, GKEY_E, 0 };	/* E */
	const uint8 key_66[] = { MOD_CAPSUNLOCK, GKEY_F, 0 };	/* F */
	const uint8 key_67[] = { MOD_CAPSUNLOCK, GKEY_G, 0 };	/* G */
	const uint8 key_68[] = { MOD_CAPSUNLOCK, GKEY_H, 0 };	/* H */
	const uint8 key_69[] = { MOD_CAPSUNLOCK, GKEY_I, 0 };	/* I */
	const uint8 key_6a[] = { MOD_CAPSUNLOCK, GKEY_J, 0 };	/* J */
	const uint8 key_6b[] = { MOD_CAPSUNLOCK, GKEY_K, 0 };	/* K */
	const uint8 key_6c[] = { MOD_CAPSUNLOCK, GKEY_L, 0 };	/* L */
	const uint8 key_6d[] = { MOD_CAPSUNLOCK, GKEY_M, 0 };	/* M */
	const uint8 key_6e[] = { MOD_CAPSUNLOCK, GKEY_N, 0 };	/* N */
	const uint8 key_6f[] = { MOD_CAPSUNLOCK, GKEY_O, 0 };	/* O */
	const uint8 key_70[] = { MOD_CAPSUNLOCK, GKEY_P, 0 };	/* P */
	const uint8 key_71[] = { MOD_CAPSUNLOCK, GKEY_Q, 0 };	/* Q */
	const uint8 key_72[] = { MOD_CAPSUNLOCK, GKEY_R, 0 };	/* R */
	const uint8 key_73[] = { MOD_CAPSUNLOCK, GKEY_S, 0 };	/* S */
	const uint8 key_74[] = { MOD_CAPSUNLOCK, GKEY_T, 0 };	/* T */
	const uint8 key_75[] = { MOD_CAPSUNLOCK, GKEY_U, 0 };	/* U */
	const uint8 key_76[] = { MOD_CAPSUNLOCK, GKEY_V, 0 };	/* V */
	const uint8 key_77[] = { MOD_CAPSUNLOCK, GKEY_W, 0 };	/* W */
	const uint8 key_78[] = { MOD_CAPSUNLOCK, GKEY_X, 0 };	/* X */
	const uint8 key_79[] = { MOD_CAPSUNLOCK, GKEY_Y, 0 };	/* Y */
	const uint8 key_7a[] = { MOD_CAPSUNLOCK, GKEY_Z, 0 };	/* Z */
	const uint8 key_7b[] = { GKEY_2NDF, GKEY_D, 0 };	/* { */
	const uint8 key_7c[] = { GKEY_2NDF, GKEY_H, 0 };	/* | */
	const uint8 key_7d[] = { GKEY_2NDF, GKEY_F, 0 };	/* } */
	const uint8 key_7e[] = { GKEY_2NDF, GKEY_J, 0 };	/* ~ */
	const uint8 key_a1[] = { MOD_KANA, GKEY_PERIOD, 0 };	/* B */
	const uint8 key_a2[] = { MOD_KANA, GKEY_LKAKKO, 0 };	/* u */
	const uint8 key_a3[] = { MOD_KANA, GKEY_RKAKKO, 0 };	/* v */
	const uint8 key_a4[] = { MOD_KANA, GKEY_COMMA, 0 };	/* A */
	const uint8 key_a5[] = { MOD_KANA, GKEY_PLUS, 0 };	/* E */
	const uint8 key_a6[] = { MOD_KANA, GKEY_W, GKEY_O, 0 };	/*  */
	const uint8 key_a7[] = { MOD_KANA, GKEY_CAPS, GKEY_A, 0 };	/* @ */
	const uint8 key_a8[] = { MOD_KANA, GKEY_CAPS, GKEY_I, 0 };	/* B */
	const uint8 key_a9[] = { MOD_KANA, GKEY_CAPS, GKEY_U, 0 };	/* D */
	const uint8 key_aa[] = { MOD_KANA, GKEY_CAPS, GKEY_E, 0 };	/* F */
	const uint8 key_ab[] = { MOD_KANA, GKEY_CAPS, GKEY_O, 0 };	/* H */
	const uint8 key_ac[] = { MOD_KANA, GKEY_CAPS, GKEY_Y, GKEY_A, 0 };	/*  */
	const uint8 key_ad[] = { MOD_KANA, GKEY_CAPS, GKEY_Y, GKEY_U, 0 };	/*  */
	const uint8 key_ae[] = { MOD_KANA, GKEY_CAPS, GKEY_Y, GKEY_O, 0 };	/*  */
	const uint8 key_af[] = { MOD_KANA, GKEY_CAPS, GKEY_T, GKEY_U, 0 };	/* b */
	const uint8 key_b0[] = { MOD_KANA, GKEY_2NDF, GKEY_KANA, 0 };	/* [ */
	const uint8 key_b1[] = { MOD_KANA, GKEY_A, 0 };	/* A */
	const uint8 key_b2[] = { MOD_KANA, GKEY_I, 0 };	/* C */
	const uint8 key_b3[] = { MOD_KANA, GKEY_U, 0 };	/* E */
	const uint8 key_b4[] = { MOD_KANA, GKEY_E, 0 };	/* G */
	const uint8 key_b5[] = { MOD_KANA, GKEY_O, 0 };	/* I */
	const uint8 key_b6[] = { MOD_KANA, GKEY_K, GKEY_A, 0 };	/* J */
	const uint8 key_b7[] = { MOD_KANA, GKEY_K, GKEY_I, 0 };	/* L */
	const uint8 key_b8[] = { MOD_KANA, GKEY_K, GKEY_U, 0 };	/* N */
	const uint8 key_b9[] = { MOD_KANA, GKEY_K, GKEY_E, 0 };	/* P */
	const uint8 key_ba[] = { MOD_KANA, GKEY_K, GKEY_O, 0 };	/* R */
	const uint8 key_bb[] = { MOD_KANA, GKEY_S, GKEY_A, 0 };	/* T */
	const uint8 key_bc[] = { MOD_KANA, GKEY_S, GKEY_I, 0 };	/* V */
	const uint8 key_bd[] = { MOD_KANA, GKEY_S, GKEY_U, 0 };	/* X */
	const uint8 key_be[] = { MOD_KANA, GKEY_S, GKEY_E, 0 };	/* Z */
	const uint8 key_bf[] = { MOD_KANA, GKEY_S, GKEY_O, 0 };	/* \ */
	const uint8 key_c0[] = { MOD_KANA, GKEY_T, GKEY_A, 0 };	/* ^ */
	const uint8 key_c1[] = { MOD_KANA, GKEY_T, GKEY_I, 0 };	/* ` */
	const uint8 key_c2[] = { MOD_KANA, GKEY_T, GKEY_U, 0 };	/* c */
	const uint8 key_c3[] = { MOD_KANA, GKEY_T, GKEY_E, 0 };	/* e */
	const uint8 key_c4[] = { MOD_KANA, GKEY_T, GKEY_O, 0 };	/* g */
	const uint8 key_c5[] = { MOD_KANA, GKEY_N, GKEY_A, 0 };	/* i */
	const uint8 key_c6[] = { MOD_KANA, GKEY_N, GKEY_I, 0 };	/* j */
	const uint8 key_c7[] = { MOD_KANA, GKEY_N, GKEY_U, 0 };	/* k */
	const uint8 key_c8[] = { MOD_KANA, GKEY_N, GKEY_E, 0 };	/* l */
	const uint8 key_c9[] = { MOD_KANA, GKEY_N, GKEY_O, 0 };	/* m */
	const uint8 key_ca[] = { MOD_KANA, GKEY_H, GKEY_A, 0 };	/* n */
	const uint8 key_cb[] = { MOD_KANA, GKEY_H, GKEY_I, 0 };	/* q */
	const uint8 key_cc[] = { MOD_KANA, GKEY_H, GKEY_U, 0 };	/* t */
	const uint8 key_cd[] = { MOD_KANA, GKEY_H, GKEY_E, 0 };	/* w */
	const uint8 key_ce[] = { MOD_KANA, GKEY_H, GKEY_O, 0 };	/* z */
	const uint8 key_cf[] = { MOD_KANA, GKEY_M, GKEY_A, 0 };	/* } */
	const uint8 key_d0[] = { MOD_KANA, GKEY_M, GKEY_I, 0 };	/* ~ */
	const uint8 key_d1[] = { MOD_KANA, GKEY_M, GKEY_U, 0 };	/*  */
	const uint8 key_d2[] = { MOD_KANA, GKEY_M, GKEY_E, 0 };	/*  */
	const uint8 key_d3[] = { MOD_KANA, GKEY_M, GKEY_O, 0 };	/*  */
	const uint8 key_d4[] = { MOD_KANA, GKEY_Y, GKEY_A, 0 };	/*  */
	const uint8 key_d5[] = { MOD_KANA, GKEY_Y, GKEY_U, 0 };	/*  */
	const uint8 key_d6[] = { MOD_KANA, GKEY_Y, GKEY_O, 0 };	/*  */
	const uint8 key_d7[] = { MOD_KANA, GKEY_R, GKEY_A, 0 };	/*  */
	const uint8 key_d8[] = { MOD_KANA, GKEY_R, GKEY_I, 0 };	/*  */
	const uint8 key_d9[] = { MOD_KANA, GKEY_R, GKEY_U, 0 };	/*  */
	const uint8 key_da[] = { MOD_KANA, GKEY_R, GKEY_E, 0 };	/*  */
	const uint8 key_db[] = { MOD_KANA, GKEY_R, GKEY_O, 0 };	/*  */
	const uint8 key_dc[] = { MOD_KANA, GKEY_W, GKEY_A, 0 };	/*  */
	const uint8 key_dd[] = { MOD_KANA, GKEY_N, GKEY_N, GKEY_RIGHT, 0 };	/*  */
	const uint8 key_de[] = { MOD_KANA, GKEY_B, GKEY_A, GKEY_LEFT, GKEY_BACKSPACE, GKEY_RIGHT, 0 };	/* J */
	const uint8 key_df[] = { MOD_KANA, GKEY_P, GKEY_A, GKEY_LEFT, GKEY_BACKSPACE, GKEY_RIGHT, 0 };	/* K */
	const uint8 key_f8[] = { GKEY_2NDF, GKEY_9, 0 };	/*  */
	const uint8 *key_table[] = {
		/* 00 */
		NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
		key_08, key_09, key_0a, NULL, NULL, key_0a, NULL, NULL,
		/* 10 */
		NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
		NULL, NULL, NULL, NULL, key_1c, key_1d, key_1e, key_1f,
		/* 20 */
		key_20, key_21, key_22, key_23, key_24, key_25, key_26, key_27,
		key_28, key_29, key_2a, key_2b, key_2c, key_2d, key_2e, key_2f,
		/* 20 */
		key_30, key_31, key_32, key_33, key_34, key_35, key_36, key_37,
		key_38, key_39, key_3a, key_3b, key_3c, key_3d, key_3e, key_3f,
		/* 40 */
		key_40, key_41, key_42, key_43, key_44, key_45, key_46, key_47,
		key_48, key_49, key_4a, key_4b, key_4c, key_4d, key_4e, key_4f,
		/* 20 */
		key_50, key_51, key_52, key_53, key_54, key_55, key_56, key_57,
		key_58, key_59, key_5a, key_5b, key_5c, key_5d, key_5e, key_5f,
		/* 20 */
		key_60, key_61, key_62, key_63, key_64, key_65, key_66, key_67,
		key_68, key_69, key_6a, key_6b, key_6c, key_6d, key_6e, key_6f,
		/* 20 */
		key_70, key_71, key_72, key_73, key_74, key_75, key_76, key_77,
		key_78, key_79, key_7a, key_7b, key_7c, key_7d, key_7e, NULL,
		/* 80 */
		NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
		NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
		/* 90 */
		NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
		NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
		/* a0 */
		NULL, key_a1, key_a2, key_a3, key_a4, key_a5, key_a6, key_a7,
		key_a8, key_a9, key_aa, key_ab, key_ac, key_ad, key_ae, key_af,
		/* b0 */
		key_b0, key_b1, key_b2, key_b3, key_b4, key_b5, key_b6, key_b7,
		key_b8, key_b9, key_ba, key_bb, key_bc, key_bd, key_be, key_bf,
		/* c0 */
		key_c0, key_c1, key_c2, key_c3, key_c4, key_c5, key_c6, key_c7,
		key_c8, key_c9, key_ca, key_cb, key_cc, key_cd, key_ce, key_cf,
		/* d0 */
		key_d0, key_d1, key_d2, key_d3, key_d4, key_d5, key_d6, key_d7,
		key_d8, key_d9, key_da, key_db, key_dc, key_dd, key_de, key_df,
		/* e0 */
		NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
		NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
		/* f0 */
		NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
		key_f8, NULL, NULL, NULL, NULL, NULL, NULL, NULL
	};
	const uint8 *p = key_table[(unsigned char )ch];
	uint8 *k = key;

	if(p == NULL)
		return 0;

	switch(*p) {
	case MOD_CAPSUNLOCK:
		p++;
		if(mod & 0x02)
			*k++ = GKEY_CAPS;
		if(mod & 0x04)
			*k++ = GKEY_KANA;
		break;
	case MOD_CAPSLOCK:
		p++;
		if(!(mod & 0x02))
			*k++ = GKEY_CAPS;
		if(mod & 0x04)
			*k++ = GKEY_KANA;
		break;
	case MOD_KANA:
		p++;
		if(!(mod & 0x04))
			*k++ = GKEY_KANA;
		break;
	default:
		if(mod & 0x04)
			*k++ = GKEY_KANA;
		break;
	}

	while(*p != 0)
		*k++ = *p++;
	*k = 0;

	return (int )(k - key);
}

/*
	͂1Xg[N
*/
uint8 getAutoKey(void)
{
	uint8 *p;

	if(autoKeyTextPointer == NULL)
		return GKEY_NONE;

	if(autoKeyBufferPointer != NULL && *autoKeyBufferPointer != 0)
		return *autoKeyBufferPointer++;

	switch(*autoKeyTextPointer) {
	case 0x00: /* NUL */
		if((memory[0x7901] ^ autoKeyMod) == 0) {
			autoKeyTextPointer = NULL;
			noWait = FALSE;
			return GKEY_NONE;
		}

		p = autoKeyBuffer;
		if((memory[0x7901] ^ autoKeyMod) & 0x02)
			*p++ = GKEY_CAPS;
		if((memory[0x7901] ^ autoKeyMod) & 0x04)
			*p++ = GKEY_KANA;
		*p++ = 0;
		break;
	case 0x1a: /* EOF */
		autoKeyTextPointer = NULL;
		noWait = FALSE;
		return GKEY_NONE;
	case 0x1b: /* ESC */
		autoKeyTextPointer++;
		autoKeyBuffer[0] = *autoKeyTextPointer++;
		autoKeyBuffer[1] = 0;
		break;
	default: /*  */
		if(ankToKey(*autoKeyTextPointer++, memory[0x7901], autoKeyBuffer) == 0) {
			autoKeyTextPointer = NULL;
			noWait = FALSE;
			return GKEY_NONE;
		}
		break;
	}

	autoKeyBufferPointer = autoKeyBuffer;
	return *autoKeyBufferPointer++;
}

/*
	UTF-8UTF-16ɕϊ (utf8ToAnk̉)
*/
static int utf8ToUtf16(const char *utf8, int *utf16)
{
	if((utf8[0] & 0x80) == 0) { /* 1oCg */
		*utf16 = *utf8;
		return 1;
	} else if((utf8[0] & 0xe0) == 0xc0) { /* 2oCg */
		*utf16 = (utf8[0] & 0x1f) << 6U | (utf8[1] & 0x3f);
		return 2;
	} else if((utf8[0] & 0xf0) == 0xe0) { /* 3oCg */
		*utf16 = (utf8[0] & 0x0fU) << 12U | (utf8[1] & 0x3fU) << 6U | (utf8[2] & 0x3fU);
		return 3;
	} else if((utf8[0] & 0xf8) == 0xf0) { /* 4oCg */
		*utf16 = 0x20;
		return 4;
	} else if((utf8[0] & 0xfc) == 0xf8) { /* 5oCg */
		*utf16 = 0x20;
		return 5;
	} else if((utf8[0] & 0xfe) == 0xfc) { /* 6oCg */
		*utf16 = 0x20;
		return 6;
	} else { /* ? */
		*utf16 = 0;
		return 1;
	}
}

/*
	UTF-161oCgɕϊ (utf8ToAnk̉)
*/
static int utf16ToAnk(int utf16, char *ank)
{
	const char *kana[] = {
		"\xde",	/* 0x309b J */
		"\xdf",	/* 0x309c K */
		"",	/* 0x309d */
		"",	/* 0x309e */
		"",	/* 0x309f */
		"",	/* 0x30a0 */
		"\xa7",	/* 0x30a1 @ */
		"\xb1",	/* 0x30a2 A */
		"\xa8",	/* 0x30a3 B */
		"\xb2",	/* 0x30a4 C */
		"\xa9",	/* 0x30a5 D */
		"\xb3",	/* 0x30a6 E */
		"\xaa",	/* 0x30a7 F */
		"\xb4",	/* 0x30a8 G */
		"\xab",	/* 0x30a9 H */
		"\xb5",	/* 0x30aa I */
		"\xb6",	/* 0x30ab J */
		"\xb6\xde",	/* 0x30ac K */
		"\xb7",	/* 0x30ad L */
		"\xb7\xde",	/* 0x30ae M */
		"\xb8",	/* 0x30af N */
		"\xb8\xde",	/* 0x30b0 O */
		"\xb9",	/* 0x30b1 P */
		"\xb9\xde",	/* 0x30b2 Q */
		"\xba",	/* 0x30b3 R */
		"\xba\xde",	/* 0x30b4 S */
		"\xbb",	/* 0x30b5 T */
		"\xbb\xde",	/* 0x30b6 U */
		"\xbc",	/* 0x30b7 V */
		"\xbc\xde",	/* 0x30b8 W */
		"\xbd",	/* 0x30b9 X */
		"\xbd\xde",	/* 0x30ba Y */
		"\xbe",	/* 0x30bb Z */
		"\xbe\xde",	/* 0x30bc [ */
		"\xbf",	/* 0x30bd \ */
		"\xbf\xde",	/* 0x30be ] */
		"\xc0",	/* 0x30bf ^ */
		"\xc0\xde",	/* 0x30c0 _ */
		"\xc1",	/* 0x30c1 ` */
		"\xc1\xde",	/* 0x30c2 a */
		"\xaf",	/* 0x30c3 b */
		"\xc2",	/* 0x30c4 c */
		"\xc2\xde",	/* 0x30c5 d */
		"\xc3",	/* 0x30c6 e */
		"\xc3\xde",	/* 0x30c7 f */
		"\xc4",	/* 0x30c8 g */
		"\xc4\xde",	/* 0x30c9 h */
		"\xc5",	/* 0x30ca i */
		"\xc6",	/* 0x30cb j */
		"\xc7",	/* 0x30cc k */
		"\xc8",	/* 0x30cd l */
		"\xc9",	/* 0x30ce m */
		"\xca",	/* 0x30cf n */
		"\xca\xde",	/* 0x30d0 o */
		"\xca\xdf",	/* 0x30d1 p */
		"\xcb",	/* 0x30d2 q */
		"\xcb\xde",	/* 0x30d3 r */
		"\xcb\xdf",	/* 0x30d4 s */
		"\xcc",	/* 0x30d5 t */
		"\xcc\xde",	/* 0x30d6 u */
		"\xcc\xdf",	/* 0x30d7 v */
		"\xcd",	/* 0x30d8 w */
		"\xcd\xde",	/* 0x30d9 x */
		"\xcd\xdf",	/* 0x30da y */
		"\xce",	/* 0x30db z */
		"\xce\xde",	/* 0x30dc { */
		"\xce\xdf",	/* 0x30dd | */
		"\xcf",	/* 0x30de } */
		"\xd0",	/* 0x30df ~ */
		"\xd1",	/* 0x30e0  */
		"\xd2",	/* 0x30e1  */
		"\xd3",	/* 0x30e2  */
		"\xac",	/* 0x30e3  */
		"\xd4",	/* 0x30e4  */
		"\xad",	/* 0x30e5  */
		"\xd5",	/* 0x30e6  */
		"\xae",	/* 0x30e7  */
		"\xd6",	/* 0x30e8  */
		"\xd7",	/* 0x30e9  */
		"\xd8",	/* 0x30ea  */
		"\xd9",	/* 0x30eb  */
		"\xda",	/* 0x30ec  */
		"\xdb",	/* 0x30ed  */
		"",	/* 0x30ee */
		"\xdc",	/* 0x30ef  */
		"",	/* 0x30f0 */
		"",	/* 0x30f1 */
		"\xa6",	/* 0x30f2  */
		"\xdd",	/* 0x30f3  */
		"\xb3\xde",	/* 0x30f4  */
		"",	/* 0x30f5 */
		"",	/* 0x30f6 */
		"",	/* 0x30f7 */
		"",	/* 0x30f8 */
		"",	/* 0x30f9 */
		"",	/* 0x30fa */
		"\xa5",	/* 0x30fb E */
		"\xb0"	/* 0x30fc [ */
	};
	char *a = ank;
	const char *p;

	if(utf16 == 0)
		;
	else if(utf16 <= 0x7f) /* ASCII */
		*a++ = utf16;
	else if(utf16 == 0x0091 || utf16 == 0x0092 || utf16 == 0x2018 || utf16 == 0x2019) /* ' */
		*a++ = 0x27;
	else if(utf16 == 0x0093 || utf16 == 0x0094 || utf16 == 0x201c || utf16 == 0x201d) /* " */
		*a++ = 0x22;
	else if(utf16 == 0x00a5 || utf16 == 0xffe5) /* \ */
		*a++ = 0x5c;
	else if(utf16 == 0x00b0) /*  */
		*a++ = 0xdf;
	else if(utf16 == 0x2032) /*  */
		*a++ = 0x27;
	else if(utf16 == 0x2033) /*  */
		*a++ = 0xf8;
	else if(utf16 == 0x3000) /*   */
		*a++ = 0x20;
	else if(utf16 == 0x3001) /* A */
		*a++ = 0xa4;
	else if(utf16 == 0x3002) /* B */
		*a++ = 0xa1;
	else if(utf16 == 0x300c) /* u */
		*a++ = 0xa2;
	else if(utf16 == 0x300d) /* v */
		*a++ = 0xa3;
	else if(0x309b <= utf16 && utf16 <= 0x309b + sizeof(kana) / sizeof(kana[0])) /* Ji */
		for(p = kana[utf16 - 0x309b]; *p != 0; p++)
			*a++ = *p;
	else if(0xff00 <= utf16 && utf16 <= 0xff9f) /* SppLEpJi */
		*a++ = utf16 - 0xff00U + 0x40;
	else if(utf16 == 0xffe3) /* ~ */
		*a++ = 0x7e;

	*a = 0;
	return (int )(a - ank);
}

/*
	UTF-8ANKɕϊ (setAutoKeyText̉)
*/
static int utf8ToAnk(const char *utf8, char *ank, int ank_size)
{
	int len = strlen(utf8), size, utf16;
	const char *u = utf8;
	char buf[8], *a = ank;

	while(u < utf8 + len) {
		u += utf8ToUtf16(u, &utf16);

		size = utf16ToAnk(utf16, buf);
		if((int )(a - ank) + size >= ank_size - 1)
			break;

		memcpy(a, buf, size + 1);
		a += size;
	}

	return (int )(a - ank);
}

/*
	L[͂eLXgݒ肷
*/
void setAutoKeyText(const char *text, int utf8)
{
	memset(autoKeyText, 0, sizeof (autoKeyText));

	if(utf8)
		utf8ToAnk(text, autoKeyText, sizeof(autoKeyText));
	else
		strncpy(autoKeyText, text, sizeof(autoKeyText) - 1);

	autoKeyMod = memory[0x7901];

	autoKeyBufferPointer = NULL;
	autoKeyTextPointer = autoKeyText;
	noWait = TRUE;
}

/*
	L[͂L[ݒ肷
*/
void setAutoKey(uint8 key)
{
	char buf[4];

	buf[0] = 0x1b;
	buf[1] = key;
	buf[2] = 0x1a;
	buf[3] = 0x00;
	setAutoKeyText(buf, FALSE);
}

/*
	ANKUTF-8ɕϊ
*/
char *ankToUtf8(const uint8 *ank, char *utf8)
{
	char *u = utf8;
	const uint8 *a;

	for(a = ank; *a != 0; a++)
		if(*a == 0xdf) { /*  */
			*u++ = 0xc2;
			*u++ = 0xb0;
		} else if(*a == 0x27) { /*  */
			*u++ = 0xe2;
			*u++ = 0x80;
			*u++ = 0xb2;
		} else if(*a == 0xf8) { /*  */
			*u++ = 0xe2;
			*u++ = 0x80;
			*u++ = 0xb3;
		} else
			*u++ = *a;

	*u = 0;
	return utf8;
}

/*
	Copyright 2005 ~ 2017 maruhiro
	All rights reserved. 

	Redistribution and use in source and binary forms, 
	with or without modification, are permitted provided that 
	the following conditions are met: 

	 1. Redistributions of source code must retain the above copyright notice, 
	    this list of conditions and the following disclaimer. 

	 2. Redistributions in binary form must reproduce the above copyright notice, 
	    this list of conditions and the following disclaimer in the documentation 
	    and/or other materials provided with the distribution. 

	THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, 
	INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
	FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL 
	THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
	SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
	PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
	OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
	WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
	OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
	ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

/* eof */
